#include <iostream>
using namespace std;

class CPolygon {
  protected:
    int width, height;
  public:
    void set_values (int a, int b) {
       width=a; height=b; 
    }
    // funcao virtual pura
    // uma classe que contem pelo menos uma funcao virtual pura e uma classe abstrata
    virtual int area () = 0;
};

class CRectangle: public CPolygon {
  public:
    int area ()
      { return (width * height); }
};

class CTriangle: public CPolygon {
  public:
    int area ()
      { return (width * height / 2); }
};

int main (int argc, char *argv[]) {
  CRectangle rect;
  CTriangle trgl;
  CPolygon * ppoly1 = &rect;
  CPolygon * ppoly2 = &trgl;
  ppoly1->set_values (4,5); // static binding - o compilador resolve de forma estatica 
  ppoly2->set_values (4,5); // static binding - o compilador resolve de forma estatica 

  // area e virtual, e portanto
  cout << ppoly1->area() << endl;  // dynamic binding - so sera resolvido em tempo de execucao
  cout << ppoly2->area() << endl; // dynamic binding - so sera resolvido em tempo de execucao
  return 0;
}